package de.avatic.taric.serializer;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import de.avatic.taric.model.Certificate;
import de.avatic.taric.model.Unit;
import de.avatic.taric.repository.CertificateRepository;
import de.avatic.taric.repository.UnitRepository;
import org.springframework.data.jdbc.core.mapping.AggregateReference;
import org.springframework.stereotype.Component;

import java.io.IOException;

@Component
public class CertificateReferenceSerializer extends JsonSerializer<AggregateReference<Certificate, Integer>> {

    private final CertificateRepository certificateRepository;

    public CertificateReferenceSerializer(CertificateRepository certificateRepository) {

        this.certificateRepository = certificateRepository;
    }

    @Override
    public void serialize(AggregateReference<Certificate, Integer> value, JsonGenerator gen, SerializerProvider serializer) throws IOException {
        if (value != null) {
            Certificate cert = certificateRepository.findById(value.getId())
                    .orElse(null);

            gen.writeObject(cert);
        } else {
            gen.writeNull();
        }
    }

}
